<?php
/**
 * @author    https://www.persianscript.ir
 * @link      https://www.persianscript.ir
 * @copyright 2019 Climaxweb
 */


if(!defined('ABSPATH')) exit();

/**
 * Design the flow of the conversation of the chatbot for a given topic
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_wp_chatbot_stories')){

    function smwpcb_wp_chatbot_stories($topic_id) {
      $smwpcb_wp_chatbot_topics_settings = get_option('smwpcb_wp_chatbot_topics_settings');
      $smwpcb_intent_dialog_flow_options = smwpcb_retrieve_dialog_flow($topic_id);
      ?>
      <input type="hidden" value="<?= $topic_id ?>" id="smwpcb_topic_id_input">
      <div class="wrap smwpcb_modal_hidden">
        <h3>Flow Editor</h3>
        <h4 class="smwpcb_small_title"><?php esc_html_e("Please design the flow for the topic ", 'smart-wordpress-chatbot'); 
        echo($smwpcb_wp_chatbot_topics_settings[$topic_id]['smwpcb_topic_name']); ?></h4>
        <h4 class="smwpcb_error_notice"><?php esc_html_e("Settings were not saved, please correct the following red panels and try again.", 'smart-wordpress-chatbot'); ?></h4>
        <h4 class="smwpcb_info_notice"><?php esc_html_e("Settings were saved correctly, please include this topic on your project to see changes.", 'smart-wordpress-chatbot'); ?></h4>
        <div class="treeGlb">
          <?php
          echo(stripslashes(base64_decode($smwpcb_intent_dialog_flow_options->topicflow)));
          ?>
        </div>
       <div class="smwpcb_action_buttons">
        <button type="button" class="btn btn-info btn-float legitRipple goBackToTopics">
          <i class="icon-search4">
            <img src="<?php echo( SMWPCB_PLUGIN_URL_DIR . '/admin/images/left-arrow.png') ?>" alt="">
          </i>
          <span><?php esc_html_e("Back", 'smart-wordpress-chatbot'); ?></span>
        </button>
        <button type="button" class="btn btn-danger btn-float btn-float-lg legitRipple" id="saveSettings" idkey="<?= $topic_id ?>">
          <i class="icon-html52">
            <img src="<?php echo( SMWPCB_PLUGIN_URL_DIR . '/admin/images/save.png') ?>" alt="">
          </i>
          <span><?php esc_html_e("Save Settings", 'smart-wordpress-chatbot'); ?></span><span class="legitRipple-ripple"></span>
        </button>
        <button type="button" class="btn btn-info btn-float btn-loading legitRipple gotoToprojects">
          <i class="icon-spinner4">
            <img src="<?php echo( SMWPCB_PLUGIN_URL_DIR . '/admin/images/analyze.png') ?>" alt="">
          </i>
          <span><?php esc_html_e("Projects", 'smart-wordpress-chatbot'); ?></span>
        </button>
       </div>
      </div>
    <div class="modal smwpcb_modal_visible"></div>
    <?php

  }

}

/**
 * Analyse the bot's message bubble for any @vars or @functions ..
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_analyseResponses')){

	function smwpcb_analyseResponses($strtoAnalyse, $functionAtts){

	  try{
	  	$stringTobeReturned = esc_html($strtoAnalyse);
	    $stringTobeReturned = stripslashes($stringTobeReturned);
	    $stringTobeReturned = str_replace('"', ' ', $stringTobeReturned);
	    $stringTobeReturned = trim(preg_replace('/\s+/', ' ', $stringTobeReturned));
	    $varibalesTable = smwpcb_get_all_table_columns_variables();
	    if(strpos($stringTobeReturned, '@+displayProducts') !== false){
	      if($functionAtts[0][0] != 0){
	        $displayFct = '<call>displayProducts ';
	        foreach ($functionAtts[0][1] as $products) {
	          foreach ($products as $product) {
	            $displayFct .= '"'.$product.'" ';
	          }
	        }
	        $displayFct .= ' </call>';
	        $stringTobeReturned = str_replace("@+displayProducts", $displayFct, $stringTobeReturned);
	      }
	    }
	    if(strpos($stringTobeReturned, '@+diplayPhoto#') !== false){
	      if($functionAtts[3][0] != 0){
	        preg_match_all('~diplayPhoto#(\d+)~', $stringTobeReturned, $arrayofids);
	        foreach ($arrayofids[1] as $id) {
	          $stringTobeReturned = str_replace('@+diplayPhoto#'.$id,'<call>returnImage "'.$functionAtts[3][1][intval($id)-1].'"</call>', $stringTobeReturned);
	        }
	      }
	    }
	    if(strpos($stringTobeReturned, '@+diplayVideo#') !== false){
	      if($functionAtts[4][0] != 0){
	        preg_match_all('~diplayVideo#(\d+)~', $stringTobeReturned, $arrayofids);
	        foreach ($arrayofids[1] as $id) {
	          $stringTobeReturned = str_replace('@+diplayVideo#'.$id,'<call>returnVideo "'.$functionAtts[4][1][intval($id)-1].'"</call>', $stringTobeReturned);
	        }
	      }
	    }
	    if(strpos($stringTobeReturned, '@-strong') !== false){
	       $stringTobeReturned = str_replace('@-strong',"<span style='font-weight:700;'>", $stringTobeReturned);
	    }
	    if(strpos($stringTobeReturned, '@-endStrong') !== false){
	       $stringTobeReturned = str_replace('@-endStrong','</span>', $stringTobeReturned);
	    }
	    if(strpos($stringTobeReturned, '@-lineBreak') !== false){
	       $stringTobeReturned = str_replace('@-lineBreak','<br>', $stringTobeReturned);
	    }
	    foreach ($varibalesTable as $variable) {
	      if(strpos($stringTobeReturned, $variable) !== false){
	        $stringTobeReturned = str_replace('@'.$variable,"<call>getVariableData \"".$variable."\"</call>", $stringTobeReturned);
	      }
	    }
	    return $stringTobeReturned;
	  }catch(Exception $e){
        $exception = "Caught exception : "
			        .$e->getMessage()
			        ."</blockquote>"
			        ."\n"."on line <b>"
			        .$e->getLine()
			        ."</b> of <i>"
			        .$e->getFile()
			        ."</i>";
        return $exception;
      }

	}

}

/**
 * parse keywords for rivescript.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_implode_keywords')){

	function smwpcb_implode_keywords($strtoAnalyse, $weight){

	    $dataStr   = preg_split('/\,+/', $strtoAnalyse);
	    $specialChar = array('[',']','.',',','\\','/','#','!','$','%','^','&','*',';',':','{','}','"','=','-','_','`','~','(',')','§','@','£','<','>','?');
	    $strreturned = '[*](';
	    for ($i=0; $i < count($dataStr); $i++) {
	        if($i!=0) $strreturned .= '|';
	        $strreturned .= strtolower(preg_replace("/\s+/", " ",str_replace($specialChar, ' ', $dataStr[$i])));
	    }
	    $strreturned .= ')[*] {weight='.$weight."} \n";
	    return $strreturned;

	}

}

/**
 * parse keywords for rivescript.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_get_faq_trigger')){

	function smwpcb_get_faq_trigger($Trgarr){
	  $rtnArr = '';
	  for ($i=0; $i < count($Trgarr); $i++) {
	    $rtnArr .= '"'.stripslashes(preg_replace("/\s+/", " ",str_replace('"', ' ', $Trgarr[$i]['triggers'][0]))).'" ';
	  }
	  return $rtnArr;
	}

}

/**
 * Get the quick reply button for a specific trigger.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_get_faq_resort')){

	function smwpcb_get_faq_resort($Trgarr){
	  $rtnArr = '';
	  for ($i=0; $i < count($Trgarr); $i++) {
	    $rtnArr .= '"'.stripslashes(preg_replace("/\s+/", " ",str_replace('"', ' ', $Trgarr[$i]['triggers'][1]))).'" ';
	  }
	  return $rtnArr;
	}

}

/**
 * Get the child key from the generated array.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_get_the_child_key')){

	function smwpcb_get_the_child_key($dataArr,$valArridElm){

	  foreach ($dataArr as $key => $value) {
	    if($value['elementID'] == $valArridElm)
	      return $key;
	  }
	  return 432244455663;

	}

}

/**
 * Generate file from the flow editor for 
 * the chatbot.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_generate_file')){

	function smwpcb_generate_file(){

	  if(isset($_POST['chatbot_brain'])){
        $dataForDB = $_POST['chatbot_brain'][0];
        $arrayForDB = $_POST['chatbot_brain'][1];
        $dataArr = $_POST['chatbot_brain'][2];
        $idkey = $_POST['chatbot_brain'][3];
        $smwpcb_data_tables_settings = get_option('smwpcb_data_tables_settings');
	    if (file_exists(SMWPCB_PLUGIN_DIR."brain/topic".$idkey.".rive")) file_put_contents(SMWPCB_PLUGIN_DIR."/brain/topic".$idkey.".rive", "");
	    $myfile = fopen(SMWPCB_PLUGIN_DIR."brain/topic".$idkey.".rive", "w") or wp_die("Unable to open file!");
	    $str='';
	    if($dataArr != array()){
	    foreach($dataArr as $Mkey => $subArr){
	        if($Mkey == 0){
	            $str .= "\t + topic".$idkey." \n";
	            $str .= "\t - ".smwpcb_analyseResponses($subArr['values']['responses'][0][0], $subArr['values']['functions']);
	            if(count($subArr['values']['responses'][0]) > 1){
	              // Prevent users from entring quotes.
	            $str .= " <call>outputResponses ".'"'.str_replace('"', '|6^9~', json_encode($subArr['values']['functions'])).'"';
	            // reponses should be in for loop
	            for ($k=1; $k < count($subArr['values']['responses'][0]); $k++) {
	              $str .= ' "'.trim(preg_replace('/\s+/', ' ', $subArr['values']['responses'][0][$k])).'"';
	            }
	            $str .= "</call> ";
	            }
	            // Condition would be to check if the admin wants the faq or not
	            // if he wants it then ( $subArr['values']['restore'][1] would be equals to 1
	            // then we should call a function that will display the options
	            if($subArr['values']['restore'][0] == "3"){
	              $str .= "<call>displayresoptions ".smwpcb_get_faq_trigger($subArr['children'])."</call>";
	              if($subArr['values']['restore'][1][1] == "yes"){
	                $str .= '<call>storeUsersResponse "'.$subArr['values']['restore'][1][2].'"</call>';
	              }
	            }
	            if($subArr['values']['restore'][0] == "1"){
	              if($subArr['values']['restore'][1][1] == "yes"){
	                $str .= '<call>storeUsersResponse "'.$subArr['values']['restore'][1][2].'"</call>';
	              }
	            }
	            $str .= '{topic='.$subArr['elementID']."}\n";
	        }
	        if($subArr['values']['restore'][0] == "2"){
	            $str .= "\n> topic ".$subArr['elementID']."\n";
	            $str .= "\t + * \n";
	            // Reponses should be in for loop
	            $valdata = "<call>validationstoreddata \"".$subArr['values']['restore'][1][1]."\" \"".$subArr['values']['restore'][1][2]."\"</call>";
	            $str .= "\t * ".$valdata." == valid => <call>storetodbwpoptions \"".$subArr['values']['restore'][1][0]."\" \"".$smwpcb_data_tables_settings[$subArr['values']['restore'][1][0]]['variable']."\"</call> ";
	            $str .= smwpcb_analyseResponses($subArr['children'][0]['responses'][0],$subArr['children'][0]['functions']);
	            if(count($subArr['children'][0]['responses']) > 1){
	              $str .= " <call>outputResponses ".'"'.str_replace('"', '|6^9~', json_encode($subArr['children'][0]['functions'])).'"';
	              for ($j=1; $j < count($subArr['children'][0]['responses']); $j++) {
	                $str .= ' "'.trim(preg_replace('/\s+/', ' ', $subArr['children'][0]['responses'][$j])).'"';
	              }
	              $str .= "</call> ";
	            }
	            if($subArr['children'][0]['restore'][1][1] == "yes"){
	               $str .= '<call>storeUsersResponse "'.$subArr['children'][0]['restore'][1][2].'"</call>';
	            }
	            if($subArr['children'][0]['restore'][0] == "3" && array_key_exists(smwpcb_get_the_child_key($dataArr,$subArr['children'][0]['elementID']),$dataArr)){
	              $str .= "<call>displayresoptions ".smwpcb_get_faq_trigger($dataArr[smwpcb_get_the_child_key($dataArr,$subArr['children'][0]['elementID'])]['children'])."</call>";
	              $str .= '{topic='.$subArr['children'][0]['elementID']."}\n";
	            }elseif($subArr['children'][0]['restore'][0] == "4"){
	                if($subArr['children'][0]['restore'][1][0] == "closeDisc"){
	                  $str .= "<call>StopConversation</call>{topic=random}\n";
	                }
	                else{
	                  if($subArr['children'][0]['restore'][1][1] == '11'){
	                    $str .= "{topic=random}<call>gotoTopic ".$subArr['children'][0]['restore'][1][0]."</call>\n";
	                  }
	                  else{
	                      if($subArr['children'][0]['restore'][1][4] == "4"){
	                        $str .= "<call>StopConversation</call>{topic=random}\n";
	                      }elseif($subArr['children'][0]['restore'][1][4] == "3"){
	                        $faqoptionsdsply = explode('|6^9~', $subArr['children'][0]['restore'][1][3]); 
	                        $str .= "<call>displayresoptions ";
	                        for ($l=0; $l<count($faqoptionsdsply) ; $l++) { 
	                          $str .= '"'.$faqoptionsdsply[$l].'" ';
	                        }
	                        $str .= "</call>";
	                        $restoreoptions = explode('|6^9~', $subArr['children'][0]['restore'][1][5]);

	                        if($restoreoptions[0] == "yes"){
				               $str .= '<call>storeUsersResponse "'.$restoreoptions[1].'"</call>';
				            }
	                        $str .= "{topic=".$subArr['children'][0]['restore'][1][1]."}\n";
	                      }else{
	                        $str .= "{topic=".$subArr['children'][0]['restore'][1][1]."}\n";
	                      }
	                  }
	               }
	            }else{
	              $str .= '{topic='.$subArr['children'][0]['elementID']."}\n";
	            }
	            $str .= "\t - ".$valdata."\n";
	            $str .= "< topic \n";
	        }
	        else{
	            $str .= "\n> topic ".$subArr['elementID']."\n";
	            if($subArr['values']['restore'][0] == "1"){
	            $str .= "\t + * \n";
	            $str .= "\t - <call>resortTofaq \"".smwpcb_analyseResponses($subArr['values']['responses'][1], $subArr['functions'])."\"  \"".$subArr['elementID']."\" \"<star>\" \"".$subArr['values']['restore'][1][0]."\" ".smwpcb_get_faq_resort($subArr['children'])."</call> \n";
	            }
	            foreach($subArr['children'] as $Nkey => $valArr){
	                // I need to invoke this one to get the topic
	                $topic = ( (smwpcb_verify_exists($valArr['elementID'], $dataArr)) ? $valArr['elementID'] : 'random' );
	                if($subArr['values']['restore'][0] == "1"){
	                  $str .= "\t + ";
	                  // keywords triggers
	                  $str .= smwpcb_implode_keywords($valArr['triggers'][0], $valArr['triggers'][2]);
	                  $str .= "\t - ".smwpcb_analyseResponses($valArr['responses'][0], $valArr['functions']);
	                  if(count($valArr['responses']) > 1){
	                  $str .= " <call>outputResponses ".'"'.str_replace('"', '|6^9~', json_encode($valArr['functions'])).'"';
	                  for ($i=1; $i < count($valArr['responses']); $i++) {
	                      $str .= ' "'.trim(preg_replace('/\s+/', ' ', $valArr['responses'][$i])).'"';
	                  }
	                  $str .= "</call> ";
	                  }
	                  if($valArr['restore'][1][1] == "yes"){
	                    $str .= '<call>storeUsersResponse "'.$valArr['restore'][1][2].'"</call>';
	                  }
	                  // We should call a function that will display the options
	                  if($valArr['restore'][0] == "3" && array_key_exists(smwpcb_get_the_child_key($dataArr,$valArr['elementID']),$dataArr)){
	                    $str .= "<call>displayresoptions ".smwpcb_get_faq_trigger($dataArr[smwpcb_get_the_child_key($dataArr,$valArr['elementID'])]['children'])."</call>";
	                    $str .= '{topic='.$topic."}\n";
	                  }elseif($valArr['restore'][0] == "4"){
	                      if($valArr['restore'][1][0] == "closeDisc"){
	                        $str .= "<call>StopConversation</call>{topic=random}\n";
	                      }
	                      else{
	                        if($valArr['restore'][1][1] == '11'){
	                          $str .= "{topic=random}<call>gotoTopic ".$valArr['restore'][1][0]."</call>\n";
	                        }
	                        else{
	                          if($valArr['restore'][1][4] == "4"){
	                            $str .= "<call>StopConversation</call>{topic=random}\n";
	                          }elseif($valArr['restore'][1][4] == "3"){
	                            $faqoptionsdsply = explode('|6^9~', $valArr['restore'][1][3]); 
	                            $str .= "<call>displayresoptions ";
	                            for ($l=0; $l<count($faqoptionsdsply) ; $l++) { 
	                              $str .= '"'.$faqoptionsdsply[$l].'" ';
	                            }
	                            $str .= "</call>";
	                            $restoreoptions = explode('|6^9~', $valArr['restore'][1][5]);

		                        if($restoreoptions[0] == "yes"){
					               $str .= '<call>storeUsersResponse "'.$restoreoptions[1].'"</call>';
					            }
	                            $str .= "{topic=".$valArr['restore'][1][1]."}\n";
	                          }else{
	                            $str .= "{topic=".$valArr['restore'][1][1]."}\n";
	                          }
	                        }
	                      }
	                  }else{
	                    $str .= '{topic='.$topic."}\n";
	                  }

	                }
	                // faq triggers
	                $str .= "\t + ";
	                $faqTrgs = ($subArr['values']['restore'][0] == "1") ? $valArr['triggers'][1] : $valArr['triggers'][0];
	                $str .= stripslashes(strtolower(preg_replace("/\s+/", " ", preg_replace("/([.,\/#!?$%\^&\*;:{}=\-_`~()])/u", " ", $faqTrgs))))."{weight=1000}\n";
	                $str .= "\t - ". smwpcb_analyseResponses($valArr['responses'][0], $valArr['functions']);
	                if(count($valArr['responses']) > 1){
	                $str .= " <call>outputResponses ".'"'.str_replace('"', '|6^9~', json_encode($valArr['functions'])).'"';
	                for ($i=1; $i < count($valArr['responses']); $i++) {
	                  $str .= ' "'.trim(preg_replace('/\s+/', ' ', $valArr['responses'][$i])).'"';
	                }
	                $str .= "</call> ";
	                }
	                if($valArr['restore'][0] == "3" && array_key_exists(smwpcb_get_the_child_key($dataArr,$valArr['elementID']),$dataArr)){
	                  // there's a piste right there
	                    $str .= "<call>displayresoptions ".smwpcb_get_faq_trigger($dataArr[smwpcb_get_the_child_key($dataArr,$valArr['elementID'])]['children'])."</call>";

	                    if($valArr['restore'][1][1] == "yes"){
		                  $str .= '<call>storeUsersResponse "'.$valArr['restore'][1][2].'"</call>';
		                }
	                    $str .= '{topic='.$topic."}\n";
	                }elseif($valArr['restore'][0] == "4"){
	                    if($valArr['restore'][1][0] == "closeDisc"){
	                      $str .= "<call>StopConversation</call>{topic=random}\n";
	                    }
	                    else{
	                        if($valArr['restore'][1][1] == '11'){
	                          $str .= "{topic=random}<call>gotoTopic ".$valArr['restore'][1][0]."</call>\n";
	                        }
	                        else{
	                          if($valArr['restore'][1][4] == "4"){
	                            $str .= "<call>StopConversation</call>{topic=random}\n";
	                          }elseif($valArr['restore'][1][4] == "3"){
	                            $faqoptionsdsply = explode('|6^9~', $valArr['restore'][1][3]); 
	                            $str .= "<call>displayresoptions ";
	                            for ($l=0; $l<count($faqoptionsdsply) ; $l++) { 
	                              $str .= '"'.$faqoptionsdsply[$l].'" ';
	                            }
	                            $str .= "</call>";
	                            $restoreoptions = explode('|6^9~', $valArr['restore'][1][5]);

		                        if($restoreoptions[0] == "yes"){
					               $str .= '<call>storeUsersResponse "'.$restoreoptions[1].'"</call>';
					            }
	                            $str .= "{topic=".$valArr['restore'][1][1]."}\n";
	                          }else{
	                            $str .= "{topic=".$valArr['restore'][1][1]."}\n";
	                          }
	                      }
	                    }

	                }else{
	                  $str .= '{topic='.$topic."}\n";
	                }
	            }
	          $str .= "< topic \n";
	        }

	      }
	    }
	    fwrite($myfile, $str);
	    fclose($myfile);
	    smwpcb_merge_files();
	    smwpcb_update_dialog_flow(base64_encode($dataForDB), $idkey);
	    smwpcb_add_update_topic_msg(serialize($arrayForDB), $idkey);
	    wp_die();
	    }

	}

}

/**
 * Merge all topics into one file
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_merge_files')){

  function smwpcb_merge_files(){

    $smwpcb_wp_chatbot_topics_settings = get_option('smwpcb_wp_chatbot_topics_settings');
    if(file_exists(SMWPCB_PLUGIN_DIR."brain/allTopics.rive")) file_put_contents(SMWPCB_PLUGIN_DIR."brain/allTopics.rive", "");
    $out = fopen(SMWPCB_PLUGIN_DIR."brain/allTopics.rive", "w") or wp_die("Unable to open file!");
    $filetexts = '';
    foreach($smwpcb_wp_chatbot_topics_settings as $chatbot_topic){
      if(file_exists(SMWPCB_PLUGIN_DIR."brain/topic".$chatbot_topic['smwpcb_topic_id'].".rive")){
        $filetexts .= file_get_contents(SMWPCB_PLUGIN_DIR."brain/topic".$chatbot_topic['smwpcb_topic_id'].".rive");
      }
    }
    fwrite($out, $filetexts);
    fclose($out);

  }

}



?>