<?php
/**
 * @author    Climaxweb <climaxwebmaxell@gmail.com>
 * @link      https://www.climaxweb.net/maxbot/
 * @copyright 2019 Climaxweb
 */


if(!defined('ABSPATH')) exit();

/**
 * Handling $_GET request on topic and flow editor
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_wp_chatbot_topics_get_request')){

    function smwpcb_wp_chatbot_topics_get_request() {
      if(isset($_GET['action']) && isset($_GET['topic'])){
        smwpcb_wp_chatbot_stories($_GET['topic']);
      }else{
        smwpcb_wp_chatbot_topics();
      }

    }

}

/**
 * Adding, editing flow editor and deleting chatbot's agent
 * profile page option.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_wp_chatbot_topics')){

    function smwpcb_wp_chatbot_topics() {

      $smwpcb_wp_chatbot_topics_settings = get_option('smwpcb_wp_chatbot_topics_settings');
      $smwpcb_plugin_rating_options = get_option('smwpcb_plugin_rating_options');
      if(isset($_POST['page_chatbot_topics_settings']) && check_admin_referer(plugin_basename(__FILE__), 'chatbot_topics_admin_referer')) {
        $topicArr = array();
        if($smwpcb_wp_chatbot_topics_settings != array())
          $topicArr['smwpcb_topic_id'] = key(array_slice($smwpcb_wp_chatbot_topics_settings, -1, 1, TRUE))+1;
        else
          $topicArr['smwpcb_topic_id'] = 0;
        $topicArr['smwpcb_topic_name'] = isset($_POST['smwpcb_topic_name']) ? sanitize_text_field($_POST['smwpcb_topic_name']) : '';
        $topicArr['smwpcb_topic_description'] = isset($_POST['smwpcb_topic_description']) ? sanitize_text_field($_POST['smwpcb_topic_description']) : 'No description';
        $topicArr['smwpcb_topic_date'] = time();
        $topicArr['smwpcb_topic_unsetted'] = "0";
        array_push($smwpcb_wp_chatbot_topics_settings, $topicArr);
        update_option( 'smwpcb_wp_chatbot_topics_settings', $smwpcb_wp_chatbot_topics_settings );
        smwpcb_insert_new_dialog_flow($topicArr['smwpcb_topic_id']);
        }
      if (isset($_POST['edit_page_chatbot_topics_settings']) && isset($_POST['smwpcb_edit_topic_key'])) {
        $idkey = sanitize_text_field($_POST['smwpcb_edit_topic_key']);
        $smwpcb_wp_chatbot_topics_settings[$idkey]['smwpcb_topic_name'] = isset($_POST['smwpcb_topic_name']) ? sanitize_text_field($_POST['smwpcb_topic_name']) : '';
        $smwpcb_wp_chatbot_topics_settings[$idkey]['smwpcb_topic_description'] = isset($_POST['smwpcb_topic_description']) ? sanitize_text_field($_POST['smwpcb_topic_description']) : 'No description';
        $smwpcb_wp_chatbot_topics_settings[$idkey]['smwpcb_topic_date'] = time();
        update_option( 'smwpcb_wp_chatbot_topics_settings', $smwpcb_wp_chatbot_topics_settings );
        }
      ?>
      <div class="wrap">
      <h1 class="wp-heading-inline"><?php esc_html_e('Topics', 'smart-wordpress-chatbot'); ?></h1>
      </div>
      <button type="button" id="add_new_agent" class="page-title-action"><?php esc_html_e('Add New', 'smart-wordpress-chatbot'); ?></button>
      <div class="notice notice-info is-dismissible"><p><?php esc_html_e('Please include the created topics to a ','smart-wordpress-chatbot');?>
      <a href="admin.php?page=smwpcb_wp_chatbot_projects">project</a> 
      <?php esc_html_e('in order to see it work on one of the available pages or posts.', 'smart-wordpress-chatbot'); ?></p><button type="button" class="notice-dismiss"><span class="screen-reader-text"><?php esc_html_e('Dismiss this notice.', 'smart-wordpress-chatbot'); ?></span></button></div>
      <div id="addmoreagent" class="addmoreprAg">
        <form action="" method="post" id="actioncbform">
      <table class="form-table">
      <tbody>
          <tr>
              <th scope="row"><label for="smwpcb_topic_name"><?php esc_html_e('Topic\'s name', 'smart-wordpress-chatbot'); ?></label></th>
              <td>
                  <input type="text" id="smwpcb_topic_name" name="smwpcb_topic_name" class="smwpcb_adjust_width" required />
                  <p class="description"><?php esc_html_e('Set the name of this topic ', 'smart-wordpress-chatbot'); ?></p>
              </td>
          </tr>
          <tr>
              <th scope="row"><label for="smwpcb_topic_description"><?php esc_html_e('Topic\'s description', 'smart-wordpress-chatbot'); ?></label></th>
              <td>
                  <textarea id="smwpcb_topic_description" name="smwpcb_topic_description" class="smwpcb_adjust_width" rows="5" required></textarea>
                  <p class="description"><?php esc_html_e('Make a description for this topic.', 'smart-wordpress-chatbot'); ?></p>
              </td>
          </tr>
      </tbody>
      </table>
      <p class="submit">
          <input type="submit" class="button-primary" id="" value="<?php esc_html_e('Add Topic', 'smart-wordpress-chatbot') ?>" />
          <input type="hidden" name="page_chatbot_topics_settings" value="submit" />
          <?php wp_nonce_field(plugin_basename(__FILE__), 'chatbot_topics_admin_referer'); ?>
          <button type="button" class="button cancelsubmit" id="cancelagentsubmit"><?php esc_html_e('Cancel', 'smart-wordpress-chatbot'); ?></button>
      </p>
      </form>
      </div>
      <?php
      if($smwpcb_wp_chatbot_topics_settings != array()){
      ?>
      <div class="tablenav top">
        <div class="alignleft actions bulkactions">
            <label for="bulk-action-selector-top" class="screen-reader-text"><?php esc_html_e('Select bulk action', 'smart-wordpress-chatbot'); ?></label>
            <select name="action" id="bulk-action-selector-top">
                <option value=""><?php esc_html_e('Bulk Actions', 'smart-wordpress-chatbot'); ?></option>
                <option value="delete-selected-topic"><?php esc_html_e('Delete', 'smart-wordpress-chatbot'); ?></option>
            </select>
            <input type="submit" class="button" id="applytopics" value="<?php esc_html_e('Apply', 'smart-wordpress-chatbot'); ?>">
        </div>
        <br class="clear">
      </div>
      <?php
      }
      ?>
      <table class="wp-list-table widefat plugins">
        <thead>
        <tr>
          <td id="cb" class="manage-column column-cb check-column smwpcb_column_fix">
            <label class="screen-reader-text" for="cb-select-all-1"><?php esc_html_e('Select All', 'smart-wordpress-chatbot'); ?></label>
            <input id="cb-select-all-1" type="checkbox">
          </td>
          <th scope="col" id="name" class="manage-column column-name column-primary"><?php esc_html_e('Topic', 'smart-wordpress-chatbot'); ?></th>
          <th scope="col" id="description" class="manage-column column-description"><?php esc_html_e('Description', 'smart-wordpress-chatbot'); ?></th>
        </tr>
        </thead>
        <tbody id="the-list">
          <?php
          if($smwpcb_wp_chatbot_topics_settings != array()){
            foreach ($smwpcb_wp_chatbot_topics_settings as $topic) {
              ?>
              <tr class="<?php echo('tabrw'.esc_attr($topic['smwpcb_topic_id']))?>">
                <th scope="row" class="check-column smwpcb_column_fix"><label class="screen-reader-text">Select <?= esc_html(stripslashes($topic['smwpcb_topic_name'])) ?></label><input type="checkbox" class="checkedTopic" value="<?= esc_attr($topic['smwpcb_topic_id']) ?>" >
                </th>
                <td class="plugin-title">
                  <strong><?= esc_html(stripslashes($topic['smwpcb_topic_name'])) ?></strong>
                  <div class="row-actions visible">
                    <span class="activate">
                      <a href="javascript:void(0)" class="edit updatecbTopic" idkey="<?= esc_attr($topic['smwpcb_topic_id']) ?>"><?php esc_html_e('Edit', 'smart-wordpress-chatbot'); ?></a> |
                    </span>
                    <span class="activate">
                      <a href="javascript:void(0)" class="edit updatecbSettingsTopic" idkey="<?= esc_attr($topic['smwpcb_topic_id']) ?>"><?php esc_html_e('Flow Editor', 'smart-wordpress-chatbot'); ?></a> |
                    </span>
                    <span class="delete">
                      <a href="javascript:void(0)" class="delete deletecbTopic" idkey="<?= esc_attr($topic['smwpcb_topic_id']) ?>"><?php esc_html_e('Delete', 'smart-wordpress-chatbot'); ?></a>
                    </span>
                  </div>
                </td>
                <td class="column-description desc">
                  <div class="plugin-description">
                    <p><?= esc_html(stripslashes($topic['smwpcb_topic_description'])) ?></p>
                  </div>
                  <div class="plugin-version-author-uri"><?php esc_html_e('Last modified on ', 'smart-wordpress-chatbot'); ?><span class="smwpcb_date_deco" title="<?= date("Y-m-d h:i:sa", $topic['smwpcb_topic_date']) ?>"><?= date("Y-m-d", esc_html($topic['smwpcb_topic_date'])) ?></span> </div>
                </td>
              </tr>
              <?php
              if($topic['smwpcb_topic_unsetted'] != "0"){
                ?>
                <tr class="plugin-update-tr">
                  <td colspan="3" class="plugin-update colspanchange">
                      <div class="notice inline notice-info notice-alt">
                          <p><?php esc_html_e('There are some new users responses that the bot couldn\'t solve them with your current flow, please make an improvement on the flow editor.', 'smart-wordpress-chatbot'); ?></p>
                      </div>
                  </td>
                </tr>
                <?php
              }
            }
          }else{
          ?>
          <tr><td colspan="3"><?php esc_html_e('No topics found.', 'smart-wordpress-chatbot'); ?></td></tr>
          <?php
          }
          ?>
        </tbody>
        <tfoot>
        <tr>
          <td id="cb" class="manage-column column-cb check-column smwpcb_column_fix">
            <label class="screen-reader-text" for="cb-select-all-1"><?php esc_html_e('Select All', 'smart-wordpress-chatbot'); ?></label>
            <input id="cb-select-all-1" type="checkbox">
          </td>
          <th scope="col" id="name" class="manage-column column-name column-primary"><?php esc_html_e('Topic', 'smart-wordpress-chatbot'); ?></th>
          <th scope="col" id="description" class="manage-column column-description"><?php esc_html_e('Description', 'smart-wordpress-chatbot'); ?></th>
        </tr>
        </tfoot>
      </table>
      <?php

    }

}



?>